#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

const int MIN_N = 1;
const int MAX_N = 1e5;
const int MIN_INTERVAL = 1;
const int MAX_INTERVAL = 1e4;

const int rnd_test_n = 30;

template <typename T> void append(vector<T> &dest, const vector<T> &orig) {
	dest.insert(dest.end(), orig.begin(), orig.end());
}

string output_tc(const vector<pair<int, int>>& intervals) {
	ostringstream oss;
    oss << intervals.size() << endl;
    for (const auto [l, r] : intervals) {
        oss << l << " " << r << endl;
    }
	return oss.str();
}

vector<string> generate_sample_tests() {
	vector<string> tests;
    tests.push_back(output_tc({{1, 2}, {3, 4}, {5, 6}}));
    tests.push_back(output_tc({{2, 4}, {3, 7}, {1, 8}, {4, 8}}));
	return tests;
}

vector<string> generate_manual_tests() {
	vector<string> tests;
	// tests.push_back(output_tc(100, 0));
	return tests;
}

vector<pair<int, int>> generateRandomIntervals(int size) {
    vector<pair<int, int>> intervals(size);
    for (int i = 0; i < size; i++) {
        intervals[i].first = rnd.next(MIN_INTERVAL, MAX_INTERVAL - 1);
        intervals[i].second = rnd.next(intervals[i].first, MAX_INTERVAL);
    }
    return intervals;
}

string rnd_test(int i){
    int min_n = MIN_N;
    int max_n = MAX_N;
    
    if(i<rnd_test_n / 3){
        max_n = 5000;
    }
    else if(i<rnd_test_n / 2){
        max_n = 20000;
    }

    int n = rnd.next(min_n, max_n);
    return(output_tc(generateRandomIntervals(n)));
}

vector<string> generate_random_tests() { 
    vector<string> tests;
    for (int i = 0; i < rnd_test_n; i++){
        tests.push_back(rnd_test(i));
    } 
    return tests;
}

string extreme_test_1(){
    return(output_tc(generateRandomIntervals(MAX_N)));
}

vector<string> generate_extreme_tests(){
    vector<string> tests;   
    tests.push_back(extreme_test_1());
    return tests;
}

int main(int argc, char *argv[]) {
	registerGen(argc, argv, 1);
	vector<string> tests;
	size_t test = 0;
	append(tests, generate_sample_tests());
	append(tests, generate_manual_tests());
	append(tests, generate_random_tests());
	append(tests, generate_extreme_tests());
	for (const auto &t : tests) {
		startTest(++test);
		cout << t;
	}
	return 0;
}